//+------------------------------------------------------------------+
//|                                                  AvgPrice MT.mq4 |
//|                              Copyright  2007, fxid10t@yahoo.com |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, fxid10t@yahoo.com"
#property link      ""

extern bool   Email.Notify       =  true;

extern bool   close.longs        =  false;
extern bool   close.shorts       =  false;

extern bool   trail.longs        =  false;
extern double long.trail.pips    =  25;
extern bool   trail.shorts       =  false;
extern double short.trail.pips   =  25;

extern bool   Adjust.long.tp     =  false;
extern double long.tp            =  0;
extern bool   Adjust.short.tp    =  false;
extern double short.tp           =  0;

extern bool   Adjust.long.sl     =  false;
extern double long.sl            =  0;
extern bool   Adjust.short.sl    =  false;
extern double short.sl           =  0;

extern bool   Plot.Old.Trades    =  true;
extern color  LongColor          =  MediumBlue;
extern color  ShortColor         =  Maroon;

double buys, sells, bap, sap, blots, slots, Lswap, Sswap, LProfit, SProfit, ssl, bsl, stp, btp,bmail,smail;
double tv, Lp2c, Sp2c;
int n,MagicNumber;
string swap,subject,mail;


int init(){Avg.Price(); comments(); return(0);}
int deinit(){
//delete all indicator created TL's
   for(int i=ObjectsTotal();i>=0;i--)  {
      if(StringSubstr(ObjectName(i),0,1)=="#")  {
         ObjectDelete(ObjectName(i));  }  }
return(0);}
int start() {  Avg.Price(); comments();

if(Plot.Old.Trades) POT();

if(close.longs)   {
   for(int i=0; i<OrdersTotal(); i++)  {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()==OP_BUY && OrderSymbol()==Symbol())   {
         OrderClose(OrderTicket(),OrderLots(),Bid,0,CLR_NONE); }  }  }

if(close.shorts)   {
   for(int ii=0; ii<OrdersTotal(); ii++)  {
      OrderSelect(ii,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()==OP_SELL && OrderSymbol()==Symbol())   {
         OrderClose(OrderTicket(),OrderLots(),Ask,0,CLR_NONE); }  }  }

if(trail.shorts)   {
   ssl=Ask+(short.trail.pips*Point);
   if( sap>0 && ssl<sap ) {
      for(int o=0; o<OrdersTotal(); o++)   {
         OrderSelect(o,SELECT_BY_POS,MODE_TRADES);
         if(OrderType()==OP_SELL && OrderSymbol()==Symbol())  {
            if(ssl<OrderStopLoss() || OrderStopLoss()>ssl || OrderStopLoss()==0)   {
               OrderModify(OrderTicket(),OrderOpenPrice(),ssl,OrderTakeProfit(),0,0);}  }  }  } }

if(trail.longs)   {     
   bsl=Bid-(long.trail.pips*Point);
   if( bap>0 && bsl>bap ) {
      for(int o1=0; o1<OrdersTotal(); o1++)   {
         OrderSelect(o1,SELECT_BY_POS,MODE_TRADES);
         if(OrderType()==OP_BUY && OrderSymbol()==Symbol())  {
            if(bsl>OrderStopLoss() || OrderStopLoss()<bsl || OrderStopLoss()==0)   {
               OrderModify(OrderTicket(),OrderOpenPrice(),bsl,OrderTakeProfit(),0,0);}  }  }  } }

if(Adjust.long.tp || Adjust.short.tp)   {ManualTP();}
if(Adjust.long.sl || Adjust.short.sl)   {ManualSL();}

comments(); Avg.Price();

if(Email.Notify)  {
/*   if(Seconds()>=58)   {  n=0; }
   if(Hour()>=8 && Hour()<=23 && (Minute()==0 || Minute()==15 || Minute()==30 || Minute()==45) &&
      !IsTesting() && (bap>0 || sap>0))  {*/
   if(bmail>bap || bmail<bap || smail>sap || smail<sap)  {   
         subject = Symbol()+" Avg Price open positions "+TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES); 
         mail = StringConcatenate("Last Tick: ",TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS),"\n",
                "Swap Long ",MarketInfo(Symbol(),MODE_SWAPLONG),"\n",
                "Swap Short ",MarketInfo(Symbol(),MODE_SWAPSHORT),"\n",
               "Average Longs:    ",bap," B.Lots: ",blots,"\n",
               "Average Shorts:   ",sap," S.Lots: ",slots,"\n",
               "Current Spread:   ",Ask-Bid,"\n",
               "AccountProfit()   ",AccountProfit(),"\n",
               "Tick Value $",MarketInfo(Symbol(),16),"\n",
               "Long Profit $",LProfit," SProfit $",SProfit,"\n",
               "Swap Longs $",Lswap," Swap Shorts $",Sswap);
         /*if(n==0) {  SendMail(subject,mail); n=1; return(0);   }*/
         bmail=bap; smail=sap; SendMail(subject,mail); return(0);  }  }

return(0);}
//+------------------------------------------------------------------+
void Avg.Price() {//copy and paste variables to before init.
/*Avg.Price*///double buys, sells, bap, sap, blots, slots, Lswap, Sswap, LProfit, SProfit;
buys=0;blots=0;sells=0;slots=0;Lswap=0;Sswap=0;LProfit=0;SProfit=0;
for(int c=0; c<OrdersTotal(); c++) {
   OrderSelect(c,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol()) {
         if(OrderType()==OP_BUY)    {  
            buys+=(OrderOpenPrice()*OrderLots()); blots+=OrderLots();
            Lswap+=OrderSwap(); LProfit+=OrderProfit();   }
         if(OrderType()==OP_SELL)   {  
            sells+=(OrderOpenPrice()*OrderLots()); slots+=OrderLots();
            Sswap+=OrderSwap(); SProfit+=OrderProfit();  }  }  }

Pips2Cover();

if(buys>0)     { bap=buys/blots; bap=NormalizeDouble(bap+Lp2c,Digits);    }
if(buys<=0)    { bap=0; }
if(sells>0)    { sap=sells/slots; sap=NormalizeDouble(sap+Sp2c,Digits);   }
if(sells<=0)   { sap=0; }

if(ObjectFind("Average Buys")>-1) ObjectMove("Average Buys",0,Time[0],bap);
if(ObjectFind("Average Sells")>-1)  ObjectMove("Average Sells",0,Time[0],sap);

if(bap==0) { ObjectDelete("Average Buys"); }// ObjectsDeleteAll(0,OBJ_ARROW);}
if(sap==0) { ObjectDelete("Average Sells");}// ObjectsDeleteAll(0,OBJ_ARROW);}
if(bap>0)   {
   ObjectCreate("Average Buys",1,0,Time[10],bap);
   ObjectSetText("Average Buys","Average Buys");
   ObjectSet("Average Buys",6,LimeGreen);
   ObjectSet("Average Buys",7,STYLE_SOLID);
   ObjectSet("Average Buys",8,1);
   ObjectSet("Average Buys",9,true);   }
if(sap>0)   {
   ObjectCreate("Average Sells",1,0,Time[10],sap);
   ObjectSetText("Average Sells","Average Sells");
   ObjectSet("Average Sells",6,LightSalmon);
   ObjectSet("Average Sells",7,STYLE_SOLID);
   ObjectSet("Average Sells",8,1);
   ObjectSet("Average Sells",9,true);   } } //end Average.Price

double Pips2Cover() {
//double tv, Lp2c, Sp2c;
tv=MarketInfo(Symbol(),16);
if(Lswap!=0) {
   if(Lswap>0) {
      Lp2c=-MathFloor(Lswap/(tv*blots))*Point;  }
   if(Lswap<0) {
      Lp2c=MathFloor(Lswap/(tv*blots))*Point;  }   }
if(Sswap!=0) {
   if(Sswap>0) {
      Sp2c=-MathFloor(Sswap/(tv*slots))*Point;  }
   if(Sswap<0) {
      Sp2c=MathFloor(Sswap/(tv*slots))*Point;  }   }  }//end Pips2Cover()

void ManualTP()   {
if(Adjust.long.tp==true)   {
   for(int o4=0; o4<OrdersTotal(); o4++)   {
      OrderSelect(o4,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()==OP_BUY && OrderSymbol()==Symbol()/* &&
         (OrderMagicNumber()==MagicNumber() || OrderMagicNumber()==10203)*/ )   {
         if(OrderTakeProfit()<long.tp || OrderTakeProfit()>long.tp)   {
         btp=long.tp;
         OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),btp,0,0);  }  }  }  }
if(Adjust.short.tp==true)  {
   for(int o5=0; o5<OrdersTotal(); o5++)  {
      OrderSelect(o5,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()==OP_SELL && OrderSymbol()==Symbol()/* &&
         (OrderMagicNumber()==MagicNumber() || OrderMagicNumber()==10203)*/ )  {
         if(OrderTakeProfit()<short.tp || OrderTakeProfit()>short.tp) {
         stp=short.tp;
         OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),stp,0,0);}}}}}

void ManualSL()   {
if(Adjust.long.sl==true)   {
   for(int o4=0; o4<OrdersTotal(); o4++)   {
      OrderSelect(o4,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()==OP_BUY && OrderSymbol()==Symbol() )   {
         if(OrderStopLoss()<long.sl || OrderStopLoss()>long.sl)   {
         bsl=long.sl;
         OrderModify(OrderTicket(),OrderOpenPrice(),bsl,OrderTakeProfit(),0,0);  }  }  }  }
if(Adjust.short.sl==true)  {
   for(int o5=0; o5<OrdersTotal(); o5++)  {
      OrderSelect(o5,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()==OP_SELL && OrderSymbol()==Symbol() )  {
         if(OrderStopLoss()<short.sl || OrderStopLoss()>short.sl) {
         ssl=short.sl;
         OrderModify(OrderTicket(),OrderOpenPrice(),ssl,OrderTakeProfit(),0,0);}}}}}

void comments()   {
string space="";/*                                                                                      "+
             "                                                                                      "+
             "                                                                                      ";*/
if(MarketInfo(Symbol(),MODE_SWAPLONG)>0) swap="longs"; else swap="shorts";
if(MarketInfo(Symbol(),MODE_SWAPLONG)<0 && MarketInfo(Symbol(),MODE_SWAPSHORT)<0) swap="your broker! :(";
   Comment(space,"Last Tick: ",TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS),"\n",
           space,"Swap Long ",MarketInfo(Symbol(),MODE_SWAPLONG),"\n",
           space,"Swap Short ",MarketInfo(Symbol(),MODE_SWAPSHORT),"\n",
           space,"Average Longs:    ",bap," B.Lots: ",blots,"\n",
           space,"Average Shorts:   ",sap," S.Lots: ",slots,"\n",
           space,"Current Spread:   ",Ask-Bid,"\n",
           space,"AccountProfit()   ",AccountProfit(),"\n",
           space,"Tick Value $",MarketInfo(Symbol(),16),"\n",
           space,"Long Profit $",LProfit," SProfit $",SProfit,"\n",
           space,"Swap Longs $",Lswap," Swap Shorts $",Sswap); }//end comments()


void POT()  {
string on, type, p, an;
datetime oot, oct;
double oop, ocp;
color clr;
for(int c=0; c<OrdersHistoryTotal(); c++) {
   OrderSelect(c,SELECT_BY_POS,MODE_HISTORY);
   if(OrderType()==OP_BUY) clr=LongColor; type=" Buy";
   if(OrderType()==OP_SELL) clr=ShortColor;   type=" Sell";
   on="#"+DoubleToStr(OrderTicket(),0);
   oot=OrderOpenTime();
   oct=OrderCloseTime();
   oop=OrderOpenPrice();
   ocp=OrderClosePrice();
//open arrow
   ObjectCreate(on+"a",22,0,oot,oop);
   ObjectSet(on+"a",6,clr);
   if(type==" Buy") {ObjectSet(on+"a",14,1);}
   if(type==" Sell") {ObjectSet(on+"a",14,2);}
//close arrow
   p=DoubleToStr(OrderProfit(),2);
   an=StringConcatenate(on,"\n","$",p);
   ObjectCreate(an,22,0,oct,ocp);
   ObjectSet(an,6,clr);
   if(type==" Buy") {ObjectSet(an,14,3);}
   if(type==" Sell") {ObjectSet(an,14,3);}
//profitablility trendline
   ObjectCreate(on,2,0,oot,oop,oct,ocp);
   ObjectSet(on,6,clr);
   ObjectSet(on,7,STYLE_SOLID);
   ObjectSet(on,9,1);
   ObjectSet(on,10,0);}}