//+------------------------------------------------------------------+
//|                                             Plot Past Trades.mq4
//|Copyright  2008, Todd Geiger aka fxid10t@yahoo.com (tageiger@comcast.net)
//|http://www.forexfactory.com/showthread.php?t=66048
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Todd Geiger aka fxid10t@yahoo.com (tageiger@comcast.net)"
#property link      "http://www.forexfactory.com/showthread.php?t=66048"

#property indicator_chart_window

extern color LongColor=MediumBlue;
extern color ShortColor=Maroon;

int init()  {return(0);}

int deinit()   {
//delete all indicator created TL's
   for(int i=ObjectsTotal();i>=0;i--)  {
      if(StringSubstr(ObjectName(i),0,1)=="#")  {
         ObjectDelete(ObjectName(i));  }  }
return(0);}

int start() {

string on, type, p, an;
datetime oot, oct;
double oop, ocp;
color clr;
for(int c=0; c<OrdersHistoryTotal(); c++) {
   OrderSelect(c,SELECT_BY_POS,MODE_HISTORY);
   if(OrderType()==OP_BUY) clr=LongColor; type=" Buy";
   if(OrderType()==OP_SELL) clr=ShortColor;   type=" Sell";
   on="#"+DoubleToStr(OrderTicket(),0);
   oot=OrderOpenTime();
   oct=OrderCloseTime();
   oop=OrderOpenPrice();
   ocp=OrderClosePrice();
//open arrow
   ObjectCreate(on+"a",22,0,oot,oop);
   ObjectSet(on+"a",6,clr);
   if(type==" Buy") {ObjectSet(on+"a",14,1);}
   if(type==" Sell") {ObjectSet(on+"a",14,2);}
//close arrow
   p=DoubleToStr(OrderProfit(),2);
   an=StringConcatenate(on,"\n","$",p);
   ObjectCreate(an,22,0,oct,ocp);
   ObjectSet(an,6,clr);
   ObjectSet(an,10,0);
   if(type==" Buy") {ObjectSet(an,14,3);}
   if(type==" Sell") {ObjectSet(an,14,3);}
//profitablility trendline
   ObjectCreate(on,2,0,oot,oop,oct,ocp);
   ObjectSet(on,6,clr);
   ObjectSet(on,7,STYLE_SOLID);
   ObjectSet(on,9,1);
   ObjectSet(on,10,0);}
return(0);  }
//+------------------------------------------------------------------+