//+------------------------------------------------------------------+
//| Dinapoli MA's.mq4
//| Copyright  2008, Todd Geiger, fxid10t@yahoo.com (tageiger@comcast.net)
//| http://www.metaquotes.net
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Todd Geiger, fxid10t@yahoo.com (tageiger@comcast.net)"
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 White
#property indicator_color2 Aqua
#property indicator_color3 Blue

//---- input parameters
extern int period=1440;

//---- indicator buffers
double ma3[];
double ma7[];
double ma25[];

int init()  {   
   IndicatorBuffers(3);

   SetIndexBuffer(0,ma3);
   SetIndexBuffer(1,ma7);
   SetIndexBuffer(2,ma25);

   SetIndexLabel(0,period+" 3x3ma");
   SetIndexLabel(1,period+" 7x5ma");
   SetIndexLabel(2,period+" 25x5ma");

   SetIndexDrawBegin(0,period/Period()*3+3);
   SetIndexDrawBegin(1,period/Period()*7+5);
   SetIndexDrawBegin(2,period/Period()*25+5);
return(0); }

int deinit()  {return(0);}

int start() {
   int limit;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- the last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- main loop
   for(int i=0; i<limit; i++)  {

//iMA(Symbol(),period,ma.period,0,ma.method,ma.price,iBarShift(Symbol(),1440,Time[i]));
  
//   ma3[i]=iMA(Symbol(),Period(),1440/Period()*3,3,0,0,i);
   ma3[i]=iMA(Symbol(),period,3,3,0,0,iBarShift(Symbol(),period,Time[i]));
   ma7[i]=iMA(Symbol(),period,7,5,0,0,iBarShift(Symbol(),period,Time[i]));
   ma25[i]=iMA(Symbol(),period,25,5,0,0,iBarShift(Symbol(),period,Time[i]));   }

return(0);}